package br.usp.poli.java.ihc;
/*
Copyright (C) 2008 Fbio Levy Siqueira (fabiolevy@yahoo.com.br)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
import javax.swing.JOptionPane;

import br.usp.poli.java.ICarta;

abstract class JogadorHumano extends JogadorIHC {
	protected ICarta[] cartas;
	private static final int NUMERO_DE_CENTESIMOS_PARA_PISCAR = 4;

	public JogadorHumano(String nome, boolean estaEmCima) {
		super(nome, estaEmCima, true);
	}
	
	protected ICarta jogarCarta(ICarta cartaNaMesa) {
		int contar = 0;
		
		if (!this.mao.temCartaJogada()) this.mao.podeJogar();
		
		while (!mao.temCartaJogada()) {
			if (contar == NUMERO_DE_CENTESIMOS_PARA_PISCAR) {
				mao.piscarNome();
				contar = 0;
			}
			try {
				Thread.sleep(100);
			} catch (Exception e) { }
			contar++;
		}
		
		mao.resetarPiscar();
		
		int jogar = this.mao.cartaJogada();
		
		if (jogar < 0) return null;
		
		return cartas[jogar];
	}
	
	public boolean pedirTruco(int valorPartida, ICarta cartaNaMesa) {
		int contar = 0;
		this.mao.podeJogar();
		
		while (!mao.temCartaJogada() && !mao.pediuTruco()) {
			if (contar == NUMERO_DE_CENTESIMOS_PARA_PISCAR) {
				mao.piscarNome();
				contar = 0;
			}
			try {
				Thread.sleep(100);
			} catch (Exception e) { }
			contar++;
		}
		
		mao.resetarPiscar();
		
		if (mao.pediuTruco()) return true;
		
		return false;
	}

	public boolean analisarTruco(int valorPartida) {
		// Descobrindo o nome do jogador que pediu truco
		String oponente = this.getOponente().getNome();
		
		if (oponente == null)
			throw new ProblemaInterface("No foi possvel encontrar o nome do oponente.");
		
		// Analizando o pedido (a partir do valor da partida)
		String pedido = null;
		if (valorPartida == 3) pedido = "truco";
		else pedido = (valorPartida) + "";
		
		// zerando o pedido de truco nesta rodada
		this.mao.zerarPedidoTruco();
		
		// Pergunta ao usurio
		String[] opcoes = {"Aceitar", "Recusar"};
		
		int resposta = JOptionPane.showOptionDialog(this.mesa.getPai(),
			    oponente + " pediu " + pedido + ". O que voc deseja fazer?",
			    "Pergunta a " + this.getNome(),
			    JOptionPane.YES_NO_OPTION,
			    JOptionPane.QUESTION_MESSAGE,
			    null,
			    opcoes,
			    opcoes[0]);
		
		if (resposta == 0) {
			this.valorPartida = valorPartida;
			this.mao.mudarValorPedidoTruco(this.valorPartida + 3);
			this.mao.habilitarPedidoTruco();
			this.getOponente().avisarAceitouTruco(this.valorPartida);
			return true;
		} else return false;
	}
}
