package br.usp.poli.java.ihc;
/*
Copyright (C) 2008 Fbio Levy Siqueira (fabiolevy@yahoo.com.br)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Desktop;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.net.URI;

import javax.swing.*;


@SuppressWarnings("serial")
final class TelaSobre extends JDialog {
	private TelaSobre atual;
	private Truco pai;

	TelaSobre(Truco pai) {
		super(pai, "Sobre...", true);
		this.setResizable(false);
		this.atual = this;
		this.pai = pai;
	}

	void mostrar() {
		this.getContentPane().setLayout(new BorderLayout(5, 5));

		// Colocando o nome do Jogo
		JPanel painelNome = new JPanel(new FlowLayout());
		JLabel nome = new JLabel(
				"<HTML><BODY><FONT SIZE=\"+1\">Jogo de Truco</FONT></BODY></HTML>",
				SwingConstants.CENTER);
		painelNome.add(nome);
		this.getContentPane().add(painelNome, BorderLayout.PAGE_START);

		// Colocando os autores
		JPanel painel = new JPanel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;

		JPanel ihc = new JPanel(new BorderLayout());
		ihc.setBorder(BorderFactory.createTitledBorder("Interface Homem-Computador"));
		ihc.add(new JLabel("Fbio Levy Siqueira", SwingConstants.CENTER));

		JPanel internoIhc = new JPanel(new FlowLayout());
		JLabel hyperlink = new JLabel("<HTML><BODY><U>Website</U></BODY></HTML>", SwingConstants.CENTER);
		hyperlink.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent arg0) {
				try {
					Desktop.getDesktop().browse(new URI("http://www.levysiqueira.com.br"));
				} catch (Exception e) {
					throw new ProblemaInterface("No foi possvel abrir a pgina solicitada.");
				}
			}

			public void mouseEntered(MouseEvent e) {
				e.getComponent().setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
			}
		});
		internoIhc.add(hyperlink);
		ihc.add(internoIhc, BorderLayout.PAGE_END);

		c.gridx = 0;
		c.gridy = 0;
		c.weightx = 1.0;
		c.insets = new Insets(5, 5, 5, 5);
		painel.add(ihc, c);

		JPanel logica = new JPanel();
		logica.setBorder(BorderFactory.createTitledBorder("Lgica do jogo"));
		String nomes = "<HTML><BODY><CENTER>";

		if (pai.getJogoManilhaFixa() == null) nomes+= "-";
		else nomes += pai.getJogoManilhaFixa().nomeDoAutor();

		nomes += "<BR>";

		if (pai.getJogoManilhaVariavel() == null) nomes+= "-";
		else nomes += pai.getJogoManilhaVariavel().nomeDoAutor();

		nomes += "</CENTER></BODY></HTML>";
		logica.add(new JLabel(nomes));
		c.gridx = 0;
		c.gridy = 1;
		c.weightx = 1.0;
		c.insets = new Insets(5, 5, 5, 5);
		painel.add(logica, c);

		JPanel cartas = new JPanel(new BorderLayout());
		cartas.setBorder(BorderFactory.createTitledBorder("Figuras das cartas"));
		cartas.add(new JLabel("<HTML><BODY><CENTER>Jesse Fuchs<BR>Tom Hart</CENTER></BODY></HTML>",
				SwingConstants.CENTER));
		JPanel interno = new JPanel(new FlowLayout());
		hyperlink = new JLabel("<HTML><BODY><U>Website</U></BODY></HTML>");
		hyperlink.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent arg0) {
				try {
					Desktop.getDesktop().browse(new URI("http://www.eludication.org/playingcards.html"));
				} catch (Exception e) {
					throw new ProblemaInterface("No foi possvel abrir a pgina solicitada.");
				}
			}

			public void mouseEntered(MouseEvent e) {
				e.getComponent().setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
			}
		});
		interno.add(hyperlink);
		cartas.add(interno, BorderLayout.PAGE_END);
		c.gridx = 0;
		c.gridy = 2;
		c.weightx = 1.0;
		c.insets = new Insets(5, 5, 5, 5);
		painel.add(cartas, c);

		// colocando barra de rolagem
		JScrollPane scroll = new JScrollPane(painel,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		this.getContentPane().add(scroll);

		// Boto Fechar
		JButton fechar = new JButton("Fechar");
		fechar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				atual.dispose();
			}

		});

		JPanel painelBotao = new JPanel(new FlowLayout());
		painelBotao.add(fechar);

		this.getContentPane().add(painelBotao, BorderLayout.PAGE_END);
		try {
			this.setMinimumSize(new Dimension(
					Integer.parseInt(Truco.obterPropriedade("largura_tela_sobre")),
					Integer.parseInt(Truco.obterPropriedade("altura_tela_sobre"))));
		} catch (NumberFormatException e) {
			throw new ProblemaInterface("Erro ao obter as propriedades do arquivo de configurao.");
		}
		this.setLocationRelativeTo(super.getParent());
		this.setAlwaysOnTop(true);
		this.setVisible(true);
	}
}
